/*
 * This file provides a very simple example on how to use MiniCppUnit
 *
 * Any feedback to the autors is really appreciated
 *
 * Authors: Pau Arum (parumi@iua.upf.es) and David Garcia (dgarcia@iua.upf.es)
 */

#include "MiniCppUnit.hxx"

class MyTestsExample : public TestFixture<MyTestsExample>
{
public:
	TEST_FIXTURE( MyTestsExample )
	{
		TEST_CASE( testAddition );
		TEST_CASE( testSubstraction );
		TEST_CASE( testException );
		TEST_CASE( testStringAddition );
	}
	void testAddition()
	{
		ASSERT_EQUALS( 2, 1+1 );
	}
	void testSubstraction()
	{
		float result = 10 - 9.9999;
		ASSERT_MESSAGE( result < 0.0001, "10 - 9.9999 should give someting < 0.0001");
	}
	void testException()
	{
		try
		{
			someCodeThatShouldThrowException();
			FAIL( "Should have rised an exception" );
		} catch (std::exception & e)
		{
			// maybe assert for string in e.what()
		}
		
	}
	void testStringAddition()
	{
		std::string result("Hello");
		result += " World";
		ASSERT_EQUALS("Hello World", result);
	}
	
private:
	void someCodeThatShouldThrowException()
	{
		throw std::exception();
	}
};

REGISTER_FIXTURE( MyTestsExample );
